#!/bin/sh
# THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
# Product #5724-C94, 5724-E69, 5724-L72, (C) COPYRIGHT International Business Machines Corp., 2002-2005.
# All Rights Reserved * Licensed Materials - Property of IBM
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
# Configuration Based Update Installer
#----------------------------------------------------------------------------------

# set DEBUG_UPDATE=yes to turn on debugging statements
DEBUG_UPDATE=

MotifLAF=com.sun.java.swing.plaf.motif.MotifLookAndFeel

success_rc=0
fail_rc=$?

LaunchTitle=$0

runInstaller=
launchInstaller=
useLocalJDK=
prepareJDK=
useJavaHome=
checkSetup=
callSetup=
checkClientSetup=
callClientSetup=
failSetup=
testJDK=
copyJDK=
failedCopyJDK=
okCopyJDK=

currentDir=`dirname $0`        

PREREQ_DISABLE_INST=
PREREQ_DISABLE_UNINST=
FOR_EFIX=
RUN_JAVA_HOME=
WP_PUI_CONFIG=


#----------------------------------------------------------------------------------
#  Initialization and setup
#----------------------------------------------------------------------------------
echo Start of [ "$LaunchTitle" ]
echo Build 20061017_1508
echo

echo Verifying installer jar:
echo   [ ProductUpdateInstaller.jar ]
echo

exec 2>output.msg

if [ -f "$currentDir"/ProductUpdateInstaller.jar ] 
   then        
   
   
      while [ "$1" ]
      	   do 	   		
      	      if [ "$1" = "-dpInstall" ]
      	 	 then 
      		      PREREQ_DISABLE_INST="-W EfixInstallPrereqErrorAction.prereqOverride=yes"
      	      elif [ "$1" = "-dpUninstall" ] 
      		 then
      		      PREREQ_DISABLE_UNINST="-W EfixUninstallPrereqError.prereqOverride=yes"
      	      elif [ "$1" = "-efixOnly" ] 
      	         then
      	              FOR_EFIX="-W UpdateActionSelect.disablePTFOptions=yes"
      	      elif [ "$1" = "-configProperties" ] 
      	         then
                      WP_PUI_CONFIG=$2
      	              shift 
      	      elif [ "$1" = "-usage" ] 
      	         then
      	              echo
      	              echo Usage: updateWizard [ -efixOnly ] [ -dpInstall ] [ -dpUninstall ] [ -configProperties cfgFile ] [ -usage ]
      		      echo
      		      echo   efixOnly         - Run the installer in EFix Processing mode only. 
      		      echo   dpInstall        - Disable install prerequisite error locking.	
      		      echo   dpUninstall      - Disable uninstall prerequisite error locking.
      		      echo   configProperties - Additional configuration properties to be passed to FixPak/fix processing.
      		      echo   usage            - Display syntax help. 
      		      echo       	
      		      exit $fail_rc            	           	  		  
      		 else 
      		      echo Usage error: [ "$1" is an unrecognized argument ]	          	          	          
      		      exit $fail_rc
      	      fi	     	       	     
      	      
      	      shift	      
      done

        #PUI @PJB WAS home not needed
        #if [ "$WAS_HOME" ] 
        #then 
        #    if [ -f "$WAS_HOME"/bin/setupCmdLine.sh ]
        #    then
        #        echo Attempting to locate setupCmdLine.sh
        #        echo
        #        callSetup=1
        #    else
        #        failSetup=1
        #    fi
        #else
        #    echo The WAS_HOME env variable MUST be set.  
        #    echo Exiting.
        #    echo
        #    exit $fail_rc
        #fi
        
        #make certain supporting files are executable . . .
        chmod -R 755 "${currentDir}"/bin
        chmod_rc=$?
        if [ 0 -ne ${chmod_rc} ]
        then
            echo Could not set execute permissions on supporting files.
            exit ${chmod_rc}
        fi

else
    echo "The installer jar (ProductUpdateInstaller) file does not exist."
    echo Exiting.
    echo
    exit $fail_rc
fi     
  
#PUI @PJB  
#if [ "$failSetup" ]
#   then        
#	echo Unable to locate setupCmdLine.sh, this is usually located beneath your
#	echo WebSphere AppServer installation, in the 'bin' directory
#	echo
#	echo Exiting.	
#	echo
#	exit $fail_rc 
#fi

#if [ "$callSetup" ]
#   then                  
#        . $WAS_HOME/bin/setupCmdLine.sh
#        testJDK=1
#fi
testJDK=1
if [ "$testJDK" ]
   then
        if [ -f "$JAVA_HOME"/bin/java ]
           then
                launchInstaller=1
           else
                echo The JDK was not found within the set JAVA_HOME:
        	echo     JAVA_HOME: [ "$JAVA_HOME"/bin/java ]
        	echo
        	echo Exiting.
        	echo
        	exit $fail_rc
        fi           
fi  
      
PLATFORM=`uname`
export PLATFORM
                 
	                   
#----------------------------------------------------------------------------------
# Set up library loading for native extfile libs
#----------------------------------------------------------------------------------

# Cases for platform specific goop.
case ${PLATFORM} in 
        Linux)
                # Select the right arch library for the utils!
                OS_ARCH=`uname -m`
                case ${OS_ARCH} in
                    i386|i486|i586|i686|i786|i886|athlon)
                        LD_LIBRARY_PATH=${currentDir}/lib/linux/i386:${LD_LIBRARY_PATH}
                        export LD_LIBRARY_PATH
                        ;;
                    ppc|ppc64)
                        LD_LIBRARY_PATH=${currentDir}/lib/linux/ppc32:${LD_LIBRARY_PATH}
                        export LD_LIBRARY_PATH
                        ;;
                    s390)
                        LD_LIBRARY_PATH=${currentDir}/lib/linux/s390:${LD_LIBRARY_PATH}
                        export LD_LIBRARY_PATH
                        ;;
                esac
                ;;
        SunOS|Solaris)
                LD_LIBRARY_PATH=${currentDir}/lib/solaris:${LD_LIBRARY_PATH}
                export LD_LIBRARY_PATH
                ;;
        HP-UX)
                SHLIB_PATH=${currentDir}/lib/hpux:${SHLIB_PATH}
                export SHLIB_PATH
                
                # Make sure this is executable or it won't load!
                if [ ! -x ${currentDir}/lib/hpux/libUnixFileUtils.sl ] ; then
                    chmod 755 ${currentDir}/lib/hpux/libUnixFileUtils.sl
                fi                 
                ;;
        AIX)    
                LIBPATH=${currentDir}/lib/aix:${LIBPATH}
                export LIBPATH
                ;;
        *)
                echo "Unknown platform: ${PLATFORM}.  Native file libraries will not be loaded."
                ;;
esac


#----------------------------------------------------------------------------------
# Installer application execution
#----------------------------------------------------------------------------------

    
#----------------------------------------------------------------------------------
# Installer application execution
#----------------------------------------------------------------------------------

#PUI @PJB
# DBG_PROP="-Dis.debug=1 -Dcom.ibm.websphere.update.ptf.log.level=5  -Dcom.ibm.ws.update.debug=true -Dcom.ibm.websphere.update.ptf.debug=true -Dcom.ibm.websphere.update.harness.debug=true"
# export DBG_PROP

if [ "$launchInstaller" ] 
  then                               
       if [ "$FOR_EFIX" ]
          then
               if [ "$PREREQ_DISABLE_INST" ]
                  then
                       if [ "$PREREQ_DISABLE_UNINST" ]
                          then        
                               runInstaller=1        
                               skip=1
                               "$JAVA_HOME"/bin/java \
                               -Xmx256m \
 	                       -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
  	                       -Dswing.defaultlaf="$MotifLAF" \
                           -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                           ${DBG_PROP} \
                           -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	                       -DCURRENT_UPDATE_DIR="${currentDir}" \
  	                       run `echo "$FOR_EFIX"` `echo "$PREREQ_DISABLE_INST"` `echo "$PREREQ_DISABLE_UNINST"`
  	                  else  
  	                       runInstaller=1	             
                               "$JAVA_HOME"/bin/java \
                               -Xmx256m \
 	                       -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
                           -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                           ${DBG_PROP} \
  	                       -Dswing.defaultlaf="$MotifLAF" \
  	                       -DCURRENT_UPDATE_DIR="${currentDir}" \
    	                       run `echo "$FOR_EFIX"` `echo "$PREREQ_DISABLE_INST"`    	                    
  	               fi
  	        fi 
  	        
  	        if [ "$PREREQ_DISABLE_UNINST" ]
                  then
                       if [ "$PREREQ_DISABLE_INST" ]
                          then   
			       if [ "$skip" ]                          
                                  then 
                                       echo
                                  else
                               	       runInstaller=1             
                               	       "$JAVA_HOME"/bin/java \
                               	       -Xmx256m \
 	                       	       -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
                                   -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                                   ${DBG_PROP} \
                                   -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	                       	       -Dswing.defaultlaf="$MotifLAF" \
  	                               -DCURRENT_UPDATE_DIR="${currentDir}" \
  	                       	       run `echo "$FOR_EFIX"` `echo "$PREREQ_DISABLE_INST"` `echo "$PREREQ_DISABLE_UNINST"`
  	                       fi
  	                  else  
  	                       runInstaller=1	             
                               "$JAVA_HOME"/bin/java \
                               -Xmx256m \
 	                       -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
                           -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                           ${DBG_PROP} \
                           -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	                       -Dswing.defaultlaf="$MotifLAF" \
  	                       -DCURRENT_UPDATE_DIR="${currentDir}" \
    	                       run `echo "$FOR_EFIX"` `echo "$PREREQ_DISABLE_UNINST"`    	                    
  	               fi
  	        fi 
  	        
  	        if [ "$runInstaller" ]
  	           then
  	           	echo
  	           else  	                
  	                runInstaller=1    
  	                
                	"$JAVA_HOME"/bin/java \
                	-Xmx256m \
 	        	-cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
                -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                ${DBG_PROP} \
                -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	        	-Dswing.defaultlaf="$MotifLAF" \
  	        	-DCURRENT_UPDATE_DIR="${currentDir}" \
  	        	run `echo "$FOR_EFIX"`
  	        fi    
  	   else  	   
  	   	if [ "$PREREQ_DISABLE_INST" ]
                   then
                        if [ "$PREREQ_DISABLE_UNINST" ]
                           then        
                               skip=1
                               runInstaller=1        
                               "$JAVA_HOME"/bin/java \
                               -Xmx256m \
 	                       -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
  	                       -Dswing.defaultlaf="$MotifLAF" \
                           -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                           ${DBG_PROP} \
                           -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	                       -DCURRENT_UPDATE_DIR="${currentDir}" \
  	                       run `echo "$PREREQ_DISABLE_INST"` `echo "$PREREQ_DISABLE_UNINST"`
  	                  else  
  	                       runInstaller=1	             
                               "$JAVA_HOME"/bin/java \
                               -Xmx256m \
 	                       -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
  	                       -Dswing.defaultlaf="$MotifLAF" \
                           -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                           ${DBG_PROP} \
                           -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	                       -DCURRENT_UPDATE_DIR="${currentDir}" \
    	                       run `echo "$PREREQ_DISABLE_INST"`    	                    
  	                fi
  	        fi 
  	        
  	        if [ "$PREREQ_DISABLE_UNINST" ]
                   then
                       if [ "$PREREQ_DISABLE_INST" ]
                          then   
                               if [ "$skip" ]
                                  then
                                        echo
                                  else
                               		runInstaller=1             
                               		"$JAVA_HOME"/bin/java \
                               		-Xmx256m \
 	                       		-cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
  	                       		-Dswing.defaultlaf="$MotifLAF" \
                                -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                                ${DBG_PROP} \
                                -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	                       		-DCURRENT_UPDATE_DIR="${currentDir}" \
  	                       		run `echo "$PREREQ_DISABLE_INST"` `echo "$PREREQ_DISABLE_UNINST"`
  	                       fi
  	                  else  
  	                       runInstaller=1	             
                               "$JAVA_HOME"/bin/java \
                               -Xmx256m \
 	                       -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
  	                       -Dswing.defaultlaf="$MotifLAF" \
                           -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
                           ${DBG_PROP} \
                           -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	                       -DCURRENT_UPDATE_DIR="${currentDir}" \
    	                       run `echo "$PREREQ_DISABLE_UNINST"`    	                    
  	               fi
  	        fi   	          	       	   
        fi
  	
  	if [ "$runInstaller" ] 
  	   then echo 
  	   else  	     
  	     echo "$JAVA_HOME"/bin/java \
  	     -Xmx256m \
 	     -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
  	     -Dswing.defaultlaf="$MotifLAF" \
         -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
         ${DBG_PROP} \
         -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	     -DCURRENT_UPDATE_DIR="${currentDir}" \
  	     run
         
  	     "$JAVA_HOME"/bin/java \
  	     -Xmx256m \
 	     -cp "$currentDir"/ProductUpdateInstaller.jar:"$currentDir"/lib/extfile.jar \
  	     -Dswing.defaultlaf="$MotifLAF" \
         -Dcom.ibm.wps.pui.configprops="$WP_PUI_CONFIG" \
         ${DBG_PROP} \
         -Dcom.ibm.wp.pui.bld.level=20061017_1508 \
  	     -DCURRENT_UPDATE_DIR="${currentDir}" \
  	     run
  	fi
  	                    	    
fi

    
echo End of [ "$LaunchTitle" ]
echo 
exit $success_rc
